<?php
namespace app\api\controller;
use think\Controller;
use think\Model;
use think\Request;
use think\Config;
use Qiniu\Auth as Auth;
use Qiniu\Storage\BucketManager;
use Qiniu\Storage\UploadManager;
use app\admin\model\ContentModel;
use app\admin\controller\Api;
header("Content-Type: text/html;charset=utf-8");
header('Access-Control-Allow-Credentials: true');
header('Access-Control-Allow-Headers:x-requested-with,content-type');
header('Access-Control-Allow-Origin:'.$_SERVER['HTTP_ORIGIN']);
header('Access-Control-Allow-Methods:GET,POST,PATCH,PUT,DELETE,OPTIONS');
header('Access-Control-Max-Age:1728000');
if($_SERVER['REQUEST_METHOD'] == 'OPTIONS') {
    exit;
}
$http_type = config('sys.site_protocol')."://";
define('WEBSITE_HOST', $http_type . $_SERVER['HTTP_HOST']);

define('LYCECHO_TOKEN', '在这里更换通讯token');
define('ERROR_INVALID_PWD', 1403);
define('ERROR_REQUERIY_FIELD', 1404);
define('ERROR_PARA', 1405);
define('ERROR_SYSTEM', 1500);

class Lycecho extends Controller {
    public function _initialize() {
        $areaindex = trim(htmlspecialchars(input('area')));
        config('sys.sys_area', $areaindex);
        config('sys.url_model', 1);
        $this->areaindex = $areaindex;


        $param = input('post.');
        $lycecho_t = intval($param['lycecho_t']);
        if(!$lycecho_t){
            return $this->lycecho_failRsp(1008, "lycecho_sign error1", "time不存在");
        }
        if (time()-$lycecho_t > 600) {
            return $this->lycecho_failRsp(1009, "lycecho_sign error2", "该token已超时！");
        }
        if (empty($param['lycecho_sign']) || $param['lycecho_sign'] != md5( LYCECHO_TOKEN.$lycecho_t)) {
            return $this->lycecho_failRsp(1003, "lycecho_sign error3", "提交的token错误");
        }

    }
    public function _empty($name) {
        $apiName = 'api_'.$name;
        if (!method_exists($this, $apiName)) {
            return $this->error();
            exit();
        }
        return $this->$apiName();
    }
    public function index(Request $request) {
        $apiName = 'api_'.$request->controller();
        if (!method_exists($this, $apiName)) {
            return $this->lycecho_failRsp(ERROR_SYSTEM);
        }
        return $this->$apiName();
    }


    /**
     * [catlist 栏目列表]
     * @param  [number] $id
     */
    public function api_categorylist() {
        $attr = $this->getattr();
        $isonecate = 0;
        $midwhere = isset($attr['ispage']) && $attr['ispage'] == 1 ? ['EQ',37] : ['NEQ',37];
        if (isset($attr['id'])) {
            if (isset($attr['seltype'])) {
                $data = db('category')
                ->alias("c")
                ->join('diymodel m', 'c.mid = m.id')
                ->where(['c.pid'=>$attr['id'],'m.id'=>$midwhere])//'m.type'=>2,
                ->field('c.id,c.title,c.etitle,c.mid,c.pid,c.desc,c.seo_title,c.seo_keywords,c.seo_desc,c.content')
                ->orderRaw('c.id asc')
                ->select();
            }else{
                $data = db('category')
                ->alias("c")
                ->join('diymodel m', 'c.mid = m.id')
                ->where(['c.id'=>$attr['id']])//,'m.type'=>2
                ->field('c.*')
                ->find();
                $isonecate = 1;
            }
        } elseif (isset($attr['mid'])) {
            if (!empty($attr['mid'])) {
                $data = db('category')
                ->alias("c")
                ->join('diymodel m', 'c.mid = m.id')
                ->where(['m.id'=>$attr['mid']])//'m.type'=>2,
                ->field('c.id,c.title,c.etitle,c.mid,c.pid,c.desc,c.seo_title,c.seo_keywords,c.seo_desc,c.content')
                ->orderRaw('c.sort desc,c.id asc')
                ->select();
            }else{
                $data = db('category')
                ->alias("c")
                ->join('diymodel m', 'c.mid = m.id')
                ->where(['m.id'=>['NOT IN',[33,34,35,37]]])//'m.type'=>2,
                ->field('c.id,c.title,c.etitle,c.mid,c.pid,c.desc,c.seo_title,c.seo_keywords,c.seo_desc,c.content')
                ->orderRaw('c.sort desc,c.id asc')
                ->select();
            }
            
        }else{
            $data = db('category')
                ->alias("c")
                ->join('diymodel m', 'c.mid = m.id')
                ->where(['m.id'=>$midwhere])//'m.type'=>2,
                ->field('c.id,c.title,c.etitle,c.mid,c.pid,c.desc,c.seo_title,c.seo_keywords,c.seo_desc,c.content')
                ->orderRaw("c.sort desc,c.id asc")
                ->select();
        }
        if ($isonecate) {
            $data['desc'] = $data['desc'] ? $data['desc'] : $data['content'];
            $data['seo_title'] = $data['seo_title'] ? $data['seo_title'] : $data['title']."-".config("sys.site_title");
            $data['seo_keywords'] = $data['seo_keywords'] ? $data['seo_keywords'] : $data['title'];
            $seo_desc = $data['seo_desc'];
            if (!$seo_desc && $data['desc']) {
                $desc = strip_tags($data['desc']);
                $desc = $this->utf8_strcut($desc, 0, 80);
                $seo_desc = $desc;
            }
            $data['seo_desc'] = $seo_desc;
            $data = $this->update_str_dq($data);
        }else{
            foreach ($data as $k => $v) {
                $data[$k]['desc'] = $v['desc'] ? $v['desc'] : $v['content'];
                $data[$k]['seo_title'] = $v['seo_title'] ? $v['seo_title'] : $v['title']."-".config("sys.site_title");
                $data[$k]['seo_keywords'] = $v['seo_keywords'] ? $v['seo_keywords'] : $v['title'];
                $seo_desc = $v['seo_desc'];
                if (!$seo_desc && $v['desc']) {
                    $desc = strip_tags($v['desc']);
                    $desc = $this->utf8_strcut($desc, 0, 80);
                    $seo_desc = $desc;
                }
                $data[$k]['seo_desc'] = $seo_desc;
                $data[$k] = $this->update_str_dq($data[$k]);
            }
        }
        
        foreach ($data as $k=>&$v22){
            $v22['parent_id'] = $v22['pid'];
        }
        return $this->lycecho_successRsp($data);
    }

    public function api_articlesave(){
        $param = input('post.');
        $content = new ContentModel();
        $param['cid'] = $param['category_id'];
        $param['seo_keywords'] = $param['tags'];
        $flag = $content->insertContent($param, $param['mid']);
        if ($flag['code'] == 1) {
            $sitemap_auto = config('sys.sitemap_auto') ? intval(config('sys.sitemap_auto')) : 0;
            if ($sitemap_auto) {
                $api = new Api();
                $api->createSitemap();
            }
        }
        return $this->lycecho_successRsp();
    }

    public function update_str_dq($str){
	    $cityname = "";
	    $provname = "";
	    if ($this->areaindex) {
	        $dbarea = db('area');
	        $city = $dbarea->where(['id'=>$this->areaindex])->find();
	        $prov = [];
	        if ($city) {
	            if ($city['pid'] == 0) {
	                $prov = $city;
	            }else{
	                $cityname = $city['stitle'];
	                $prov = top_aera($city['pid']);
	            }
	        }
	        if ($prov) {
	            $provname = $prov['stitle'];
	        }
	    }
	    if (is_object($str)) {
	        $str = $str->toarray();
	    }
	    if (is_array($str)) {
	        foreach ($str as $k111 => $v111) {
	            if (is_string($v111)) {
	                $v111 =  str_replace('[prov]', $provname, $v111);
	                $v111 =  str_replace('[city]', $cityname, $v111);
	                $v111 =  str_replace('[prov_or_city]', $cityname ? $cityname : $provname, $v111);
	                $str[$k111] = $v111;
	            }
	        }
	    }else{
	        $str = str_replace('[prov]', $provname, $str);
	        $str = str_replace('[city]', $cityname, $str);
	        $str =  str_replace('[prov_or_city]', $cityname ? $cityname : $provname, $str);
	    }
	    return $str;
	}


    public function getattr(){
        //$attr = input();
        $request_body = file_get_contents('php://input');
        $attr = json_decode($request_body, true);
        return $attr;
    }
    //图片更正处理
    private function imgamend($res){
        if (config('sys.image_watermark')) {
            $image = \Image\Image::open('.'.$res['image_name']);
            if (config('sys.image_watermark') == 1) {
                $font = '.'.config('sys.image_watermark_text_font');
                if (is_file($font)) {
                    $image->text(config('sys.image_watermark_text'), $font, config('sys.image_watermark_text_size'), "#".config('sys.image_watermark_text_color'),config('sys.image_watermark_pos'),0,config('sys.image_watermark_text_angle'))
                    ->save('.'.$res['image_name']);
                }else{
                    $res['status'] = 0;
                    $res['error_info'] = '水印文字，不存在的字体文件';
                    return json_encode($res);
                }
            }else{
                if (is_file('.'.config('sys.image_watermark_pic'))) {
                    $image->water('.'.config('sys.image_watermark_pic'), config('sys.image_watermark_pos'), config('sys.image_watermark_pic_opacity'))
                    ->save('.'.$res['image_name']);
                }else{
                    $res['status'] = 0;
                    $res['error_info'] = '水印图片，不存在的图片文件';
                    return json_encode($res);
                }
            }
        }
        if (config('sys.qiniu')) {
            try {
                require_once  ROOT_PATH.'app/extend/Qiniu/autoload.php';
                //上传到七牛后保存的文件名
                $key = substr($res['image_name'], 1);
                // 需要填写你的 Access Key 和 Secret Key
                $accessKey = config('sys.qiniu_accesskey');
                $secretKey = config('sys.qiniu_secretkey');
                $auth = new Auth($accessKey, $secretKey);
                $bucket = config('sys.qiniu_bucket');
                $domain = config('sys.qiniu_domain');
                $token = $auth->uploadToken($bucket);
                $uploadMgr = new UploadManager();
                list($ret, $err) = $uploadMgr->putFile($token, $key, '.'.$res['image_name']);
                if ($err !== null) {
                    $res['status'] = 0;
                    $res['error_info'] = is_object($err) ? "七牛云配置异常，请检查" : $err ;
                } else {
                    $res['status'] = 1;
                    $res['image_name'] = $domain . $ret['key'];
                }
            } catch (Exception $e) {
                $res['status'] = 0;
                $res['error_info'] = '七牛云配置异常，请检查';
                return json_encode($res);
            }
        }else{
            $res['image_name'] = config('sys.site_protocol').'://'.config('sys.site_url').$res['image_name'];
        }
        return $res;
    }

    public function utf8_strcut($str, $start, $length=null) {   
		preg_match_all('/./us', $str, $match);   
		$chars = is_null($length)? array_slice($match[0], $start ) : array_slice($match[0], $start, $length);   
		unset($str);
		return implode('', $chars);   
	}
    public function checkorderstr($orderstr){
        $orderstr = strtolower(str_replace(" ","",$orderstr));
        if (preg_match("/^[a-z]*$/", $orderstr)) {
            return true;
        }else{
            return false;
        }
    }


    private function lycecho_successRsp($data = "", $msg = "") {
        $this->lycecho_rsp(1, $data, $msg);
    }

    private function lycecho_failRsp($code = 0, $data = "", $msg = "") {
        $this->lycecho_rsp($code, $data, $msg);
    }

    private function lycecho_rsp($code = 0, $data = "", $msg = "") {
        die(json_encode(array( "code" => $code, "data" => $data, "msg" => urlencode($msg))) );
    }

}